Debian Bug report logs - #638236
libatlas3-base: when the LAPACK alternative points to ATLAS, the BLAS alternative should always point to ATLAS

version graph

Package: libatlas3gf-base; Maintainer for libatlas3gf-base is Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>; Source for libatlas3gf-base is src:atlas.

Reported by: Jonathan Nieder <jrnieder@gmail.com>

Date: Wed, 17 Aug 2011 22:24:05 UTC

Severity: important

Merged with 576972, 598638, 624318, 676726, 684064

Found in versions atlas/3.8.3-27, atlas/3.8.4-3

Fix blocked by 521813: dpkg: [U-A] please allow hooks after selecting an alternative

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>:
Bug#638236; Package libatlas3gf-base. (Wed, 17 Aug 2011 22:24:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
New Bug report received and forwarded. Copy sent to Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>. (Wed, 17 Aug 2011 22:24:08 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: submit@bugs.debian.org
Subject: /usr/lib/liblapack.so.3gf: undefined symbol: ATL_chem
Date: Wed, 17 Aug 2011 17:22:14 -0500
Package: libatlas3gf-base
Version: 3.8.4-3
Severity: important

Hi,

Trying to build r-base:

| make[5]: Entering directory `/tmp/r-base-2.13.1/src/library/grDevices'
| Warning in solve.default(rgb) :
|   unable to load shared object '/tmp/r-base-2.13.1/modules//lapack.so':
|   /usr/lib/liblapack.so.3gf: undefined symbol: ATL_chemv
| Error in solve.default(rgb) : lapack routines cannot be loaded
| Error: unable to load R code in package 'grDevices'
| Execution halted
| make[5]: *** [mklazy] Error 1

Hmm.  So:

| $ readlink /etc/alternatives/liblapack.so.3gf
| /usr/lib/atlas-base/atlas/liblapack.so.3gf
| $ dpkg-query -S /usr/lib/atlas-base/atlas/liblapack.so.3gf
| libatlas3gf-base: /usr/lib/atlas-base/atlas/liblapack.so.3gf
| # dpkg-query -W libatlas3gf-base
| libatlas3gf-base	3.8.4-3

And:

| $ python
| Python 2.7.2+ (default, Aug 16 2011, 09:23:59) 
| [GCC 4.6.1] on linux2
| Type "help", "copyright", "credits" or "license" for more information.
| >>> import numpy
| Traceback (most recent call last):
[...]
|     from numpy.linalg import lapack_lite
| ImportError: /usr/lib/liblapack.so.3gf: undefined symbol: ATL_chemv

Severity is just important because I don't know if it's just me.
Ideas?

Jonathan

| $ ls -l /etc/alternatives/libblas.so.3gf
| /usr/lib/openblas-base/libopenblas.so.0

-- System Information:
Debian Release: wheezy/sid
  APT prefers experimental
  APT policy: (990, 'experimental'), (500, 'proposed-updates'), (500, 'unstable'), (500, 'testing'), (500, 'stable')
Architecture: amd64 (x86_64)

Kernel: Linux 3.0.0-1-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages libatlas3gf-base depends on:
ii  libc6                         2.13-16    Embedded GNU C Library: Shared lib
ii  libgcc1                       1:4.6.1-7  GCC support library
ii  libgfortran3                  4.6.1-7    Runtime library for GNU Fortran ap

libatlas3gf-base recommends no packages.

Versions of packages libatlas3gf-base suggests:
ii  liblapack3gf                  3.3.1-1    library of linear algebra routines

-- no debconf information





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>:
Bug#638236; Package libatlas3gf-base. (Wed, 17 Aug 2011 22:45:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>. (Wed, 17 Aug 2011 22:45:06 GMT) Full text and rfc822 format available.

Message #10 received at 638236@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: 638236@bugs.debian.org
Subject: Re: /usr/lib/liblapack.so.3gf: undefined symbol: ATL_chem
Date: Wed, 17 Aug 2011 17:40:12 -0500
forcemerge 638236 624318
# declared dependencies are incomplete
severity 624318 serious
quit

Jonathan Nieder wrote:

> | $ ls -l /etc/alternatives/libblas.so.3gf
> | /usr/lib/openblas-base/libopenblas.so.0

Ah, so apparently this was the problem --- atlas relies on libblas.so.3gf
defining some private functions.

How about this patch?  It fixes the policy "must" violation (§3.5,
incomplete dependencies) by introducing a policy "should" violation
(§2.5, conflict with optional package).
---
 debian/changelog |    8 ++++++++
 debian/control   |    1 +
 2 files changed, 9 insertions(+), 0 deletions(-)

diff --git a/debian/changelog b/debian/changelog
index 0d24ac4d..3339f19a 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,3 +1,11 @@
+atlas (3.8.4-3.1) local; urgency=low
+
+  * Declare incompatibility between libatlas3gf-base and other
+    libblas.so.3gf providers using a Breaks relation in debian/control
+    (Closes: #624318)
+
+ -- Jonathan Nieder <jrnieder@gmail.com>  Wed, 17 Aug 2011 17:37:24 -0500
+
 atlas (3.8.4-3) unstable; urgency=low
 
   * Revert change about devscripts being in the build-dep (see bug #628104)
diff --git a/debian/control b/debian/control
index e12ff657..a370d218 100644
--- a/debian/control
+++ b/debian/control
@@ -23,6 +23,7 @@ Conflicts: atlas2 (<< 3.2.1-1), libblas3gf (<< 1.2-5),
  libatlas3gf-corei7sse3 (<< 3.8.3-25), libatlas3gf-altivec (<< 3.8.3-25), 
  libatlas3gf-v9 (<< 3.8.3-25), libatlas3gf-ev6 (<< 3.8.3-25), 
  libatlas3gf-2.0 (<< 3.8.3-25)
+Breaks: libblas.so.3gf
 Replaces: atlas2 (<< 3.2.1-1),  libatlas3gf-sse (<< 3.8.3-25), 
  libatlas3gf-sse2 (<< 3.8.3-25), libatlas3gf-sse3 (<< 3.8.3-25), 
  libatlas3gf-core2sse3 (<< 3.8.3-25), libatlas3gf-amd64sse3 (<< 3.8.3-25),
-- 
1.7.6





Forcibly Merged 576972 598638 624318 638236. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Wed, 17 Aug 2011 22:45:09 GMT) Full text and rfc822 format available.

Severity set to 'serious' from 'important' Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Wed, 17 Aug 2011 22:45:11 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>:
Bug#638236; Package libatlas3gf-base. (Wed, 17 Aug 2011 23:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sylvestre Ledru <sylvestre@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>. (Wed, 17 Aug 2011 23:00:03 GMT) Full text and rfc822 format available.

Message #19 received at 638236@bugs.debian.org (full text, mbox):

From: Sylvestre Ledru <sylvestre@debian.org>
To: Jonathan Nieder <jrnieder@gmail.com>, 638236@bugs.debian.org
Subject: Re: Bug#638236: /usr/lib/liblapack.so.3gf: undefined symbol: ATL_chem
Date: Thu, 18 Aug 2011 00:57:17 +0200
forcemerge 638236 598638
> Jonathan Nieder wrote:
> 
> > | $ ls -l /etc/alternatives/libblas.so.3gf
> > | /usr/lib/openblas-base/libopenblas.so.0
> 
> Ah, so apparently this was the problem --- atlas relies on libblas.so.3gf
> defining some private functions.
> 
> How about this patch?  
Sorry but no. It is not the right solution.

See here for the full description of the issue:
http://lists.debian.org/debian-dpkg/2011/02/msg00069.html
and the source of the issue:
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=521813

Update blas to use the one provided by atlas and it should fix your
problem.

I am considering a potential improvement which might fix the issue.

Sorry about that,
Sylvestre






Information forwarded to debian-bugs-dist@lists.debian.org, Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>:
Bug#638236; Package libatlas3gf-base. (Wed, 17 Aug 2011 23:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>. (Wed, 17 Aug 2011 23:09:03 GMT) Full text and rfc822 format available.

Message #24 received at 638236@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Sylvestre Ledru <sylvestre@debian.org>
Cc: 638236@bugs.debian.org
Subject: Re: /usr/lib/liblapack.so.3gf: undefined symbol: ATL_chem
Date: Wed, 17 Aug 2011 18:06:11 -0500
Sylvestre Ledru wrote:

> It is not the right solution.

While I agree, it fixes (or works around and declares, if you prefer)
a serious bug, today.  So if other plans fall through, I would still
encourage you to consider it.

[...]
> I am considering a potential improvement which might fix the issue.

Thanks!  That's very good to hear.

Cheers,
Jonathan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>:
Bug#638236; Package libatlas3gf-base. (Sun, 16 Oct 2011 01:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>. (Sun, 16 Oct 2011 01:36:03 GMT) Full text and rfc822 format available.

Message #29 received at 638236@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Sylvestre Ledru <sylvestre@debian.org>
Cc: 638236@bugs.debian.org
Subject: Re: /usr/lib/liblapack.so.3gf: undefined symbol: ATL_chem
Date: Sat, 15 Oct 2011 20:33:47 -0500
Sylvestre Ledru wrote:

> I am considering a potential improvement which might fix the issue.

Ping.  Any details about that, or any other way that people interested
in seeing this fixed can help out?




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>:
Bug#638236; Package libatlas3gf-base. (Thu, 27 Oct 2011 23:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Encolpe Degoute <encolpe.degoute@free.fr>:
Extra info received and forwarded to list. Copy sent to Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>. (Thu, 27 Oct 2011 23:36:03 GMT) Full text and rfc822 format available.

Message #34 received at 638236@bugs.debian.org (full text, mbox):

From: Encolpe Degoute <encolpe.degoute@free.fr>
To: Sylvestre Ledru <sylvestre@debian.org>
Cc: 638236@bugs.debian.org, Jonathan Nieder <jrnieder@gmail.com>
Subject: /usr/lib/liblapack.so.3gf: undefined symbol: ATL_chem
Date: Fri, 28 Oct 2011 01:33:37 +0200
Hello,

I got this working by removing the libopenblas-base package.

Regards
-- 
Encolpe DEGOUTE
http://encolpe.degoute.free.fr/
Logiciels libres, hockey sur glace et autres activités cérébrales




Severity set to 'important' from 'serious' Request was from Sébastien Villemot <sebastien.villemot@ens.fr> to control@bugs.debian.org. (Mon, 11 Jun 2012 21:48:17 GMT) Full text and rfc822 format available.

Merged 576972 598638 624318 638236 676726 Request was from Sébastien Villemot <sebastien.villemot@ens.fr> to control@bugs.debian.org. (Mon, 11 Jun 2012 21:48:20 GMT) Full text and rfc822 format available.

Severity set to 'serious' from 'important' Request was from Sébastien Villemot <sebastien.villemot@ens.fr> to control@bugs.debian.org. (Tue, 12 Jun 2012 06:27:06 GMT) Full text and rfc822 format available.

Marked as found in versions atlas/3.8.3-27. Request was from Sébastien Villemot <sebastien.villemot@ens.fr> to control@bugs.debian.org. (Wed, 13 Jun 2012 16:33:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>:
Bug#638236; Package libatlas3gf-base. (Fri, 15 Jun 2012 08:45:18 GMT) Full text and rfc822 format available.

Acknowledgement sent to Laurent Bonnaud <Laurent.Bonnaud@inpg.fr>:
Extra info received and forwarded to list. Copy sent to Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>. (Fri, 15 Jun 2012 08:45:18 GMT) Full text and rfc822 format available.

Message #47 received at 638236@bugs.debian.org (full text, mbox):

From: Laurent Bonnaud <Laurent.Bonnaud@inpg.fr>
To: 638236@bugs.debian.org
Subject: Re: undefined symbol: ATL_chem
Date: Fri, 15 Jun 2012 10:37:03 +0200
Hi,

this bug is still there in this package version:
 
Package: libatlas3-base
Version: 3.8.4-7

One easy way to check for the presence of this bug is:

$ php
PHP Warning:  PHP Startup: Unable to load dynamic library '/usr/lib/php5/20100525+lfs/php_mapscript.so' - /usr/lib/liblapack.so.3gf: undefined symbol: ATL_chemv in Unknown on line 0

-- 
Laurent Bonnaud <Laurent.Bonnaud@inpg.fr>





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>:
Bug#638236; Package libatlas3gf-base. (Fri, 15 Jun 2012 09:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sébastien Villemot <sebastien.villemot@ens.fr>:
Extra info received and forwarded to list. Copy sent to Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>. (Fri, 15 Jun 2012 09:18:22 GMT) Full text and rfc822 format available.

Message #52 received at 638236@bugs.debian.org (full text, mbox):

From: Sébastien Villemot <sebastien.villemot@ens.fr>
To: Laurent Bonnaud <Laurent.Bonnaud@inpg.fr>
Cc: 638236@bugs.debian.org
Subject: Re: Bug#638236: undefined symbol: ATL_chem
Date: Fri, 15 Jun 2012 11:15:17 +0200
[Message part 1 (text/plain, inline)]
Laurent Bonnaud <Laurent.Bonnaud@inpg.fr> writes:


> this bug is still there in this package version:
>  
> Package: libatlas3-base
> Version: 3.8.4-7
>
> One easy way to check for the presence of this bug is:
>
> $ php
> PHP Warning:  PHP Startup: Unable to load dynamic library '/usr/lib/php5/20100525+lfs/php_mapscript.so' - /usr/lib/liblapack.so.3gf: undefined symbol: ATL_chemv in Unknown on line 0

No, I think you've hit #576972.

Looks like your BLAS alternative is set to Refblas or Openblas, while
your LAPACK alternative is set to ATLAS.

You must make sure that they are consistent:

 sudo update-alternatives --config libblas.so.3
 sudo update-alternatives --config liblapack.so.3

Best,

-- 
Sébastien Villemot
Researcher in Economics & Debian Maintainer
http://www.dynare.org/sebastien
Phone: +33-1-40-77-84-04 - GPG Key: 4096R/381A7594
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>:
Bug#638236; Package libatlas3gf-base. (Fri, 15 Jun 2012 09:21:31 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sébastien Villemot <sebastien.villemot@ens.fr>:
Extra info received and forwarded to list. Copy sent to Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>. (Fri, 15 Jun 2012 09:21:33 GMT) Full text and rfc822 format available.

Message #57 received at 638236@bugs.debian.org (full text, mbox):

From: Sébastien Villemot <sebastien.villemot@ens.fr>
To: Laurent Bonnaud <Laurent.Bonnaud@inpg.fr>
Cc: 638236@bugs.debian.org
Subject: Re: Bug#638236: undefined symbol: ATL_chem
Date: Fri, 15 Jun 2012 11:18:52 +0200
[Message part 1 (text/plain, inline)]
Laurent Bonnaud <Laurent.Bonnaud@inpg.fr> writes:

> this bug is still there in this package version:

Sorry, you are right (I was confusing two bugs).

This bug is still present, and it is the reason why it is not yet
closed…

If you have any idea on how to solve this, it is very welcome.

-- 
Sébastien Villemot
Researcher in Economics & Debian Maintainer
http://www.dynare.org/sebastien
Phone: +33-1-40-77-84-04 - GPG Key: 4096R/381A7594
[Message part 2 (application/pgp-signature, inline)]

Added blocking bug(s) of 638236: 521813 Request was from Sébastien Villemot <sebastien.villemot@ens.fr> to control@bugs.debian.org. (Sat, 16 Jun 2012 07:54:20 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>:
Bug#638236; Package libatlas3gf-base. (Thu, 28 Jun 2012 09:19:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sébastien Villemot <sebastien.villemot@ens.fr>:
Extra info received and forwarded to list. Copy sent to Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>. (Thu, 28 Jun 2012 09:19:18 GMT) Full text and rfc822 format available.

Message #64 received at 638236@bugs.debian.org (full text, mbox):

From: Sébastien Villemot <sebastien.villemot@ens.fr>
To: 576972@bugs.debian.org, 598638@bugs.debian.org, 624318@bugs.debian.org, 638236@bugs.debian.org, 676726@bugs.debian.org
Subject: Workaround implemented in atlas 3.8.4-8
Date: Thu, 28 Jun 2012 11:16:36 +0200
[Message part 1 (text/plain, inline)]
Hi,

It seems impossible to elegantly solve this bug without having hooks in
update-alternatives (a wishlist bug is filed for that).

In the meantime, a workaround has been implemented in order to minimize
the incidence of this bug.

Starting from version 3.8.4-8 of Atlas, the Lapack alternative provided
by Atlas has a lower priority than the one provided by Netlib's
reference Lapack. That means that the bug will never hit as long as the
alternatives are left in automatic mode (which is the default).

The downside is that one won't automatically benefit from the
optimizations made by Atlas into Lapack, unless the alternative is
manually modified.

The decision to implement this solution has been made jointly by
Sylvestre Ledru (maintainer), Julien Cristau (Release Team) and myself,
during the Debian Science Sprint kindly sponsored by ESRF, Grenoble,
France.

-- 
Sébastien Villemot
Researcher in Economics & Debian Maintainer
http://www.dynare.org/sebastien
Phone: +33-1-40-77-84-04 - GPG Key: 4096R/381A7594
[Message part 2 (application/pgp-signature, inline)]

Changed Bug title to 'libatlas3-base: when the LAPACK alternative points to ATLAS, the BLAS alternative should always point to ATLAS' from '/usr/lib/liblapack.so.3gf: undefined symbol: ATL_chem' Request was from Sébastien Villemot <sebastien@debian.org> to control@bugs.debian.org. (Mon, 15 Oct 2012 20:12:07 GMT) Full text and rfc822 format available.

Severity set to 'important' from 'serious' Request was from Michael Gilbert <michael.s.gilbert@gmail.com> to 576972-submit@bugs.debian.org. (Mon, 19 Nov 2012 01:33:04 GMT) Full text and rfc822 format available.

Merged 576972 598638 624318 638236 676726 684064 Request was from Roberto C. Sanchez <roberto@connexer.com> to control@bugs.debian.org. (Mon, 23 Sep 2013 12:12:12 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 23:19:20 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.